/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#ifndef _TRIOS_NSSI_TYPES_XDR_H_RPCGEN
#define _TRIOS_NSSI_TYPES_XDR_H_RPCGEN

#include <Trios_nssi_types_xdr.h>


#ifdef __cplusplus
extern "C" {
#endif

#include "Trios_xdr.h"
#include "Trios_nnti_xdr.h"

enum nssi_return_codes {
	NSSI_OK = 0,
	NSSI_EIO = 1001,
	NSSI_EMSGSIZE = 1001 + 1,
	NSSI_ECANCELED = 1001 + 2,
	NSSI_ETIMEDOUT = 1001 + 3,
	NSSI_EINVAL = 1001 + 4,
	NSSI_ENOMEM = 1001 + 5,
	NSSI_ENOENT = 1001 + 6,
	NSSI_ENOTSUP = 1001 + 7,
	NSSI_EEXIST = 1001 + 8,
	NSSI_EBADRPC = 1001 + 9,
	NSSI_ENOTINIT = 1001 + 10,
	NSSI_EPERM = 1001 + 11,
	NSSI_EDECODE = 1001 + 12,
	NSSI_EENCODE = 1001 + 13,
	NSSI_EWOULDBLOCK = 1001 + 14,
	NSSI_EAGAIN = 1001 + 15
};
typedef enum nssi_return_codes nssi_return_codes;

typedef uint64_t nssi_size;

typedef uint64_t nssi_ssize;
#define NSSI_HOSTNAME_LEN NNTI_HOSTNAME_LEN
#define NSSI_URL_LEN NNTI_URL_LEN

enum nssi_rpc_transport {
	NSSI_RPC_NULL = 0,
	NSSI_RPC_PTL = 1,
	NSSI_RPC_IB = 2,
	NSSI_RPC_GEMINI = 3,
	NSSI_RPC_BGPDCMF = 4,
	NSSI_RPC_BGQPAMI = 5,
	NSSI_RPC_MPI = 6,
	NSSI_RPC_LOCAL = 7
};
typedef enum nssi_rpc_transport nssi_rpc_transport;
#define NSSI_RPC_COUNT 8

enum nssi_rpc_encode {
	NSSI_RPC_XDR = 0
};
typedef enum nssi_rpc_encode nssi_rpc_encode;
#define DEFAULT_RPC_TIMEOUT 10000000

struct nssi_service {
	NNTI_transport_id_t transport_id;
	nssi_rpc_encode rpc_encode;
	NNTI_peer_t svc_host;
	NNTI_buffer_t req_addr;
	int32_t req_size;
	int32_t res_size;
	int32_t max_reqs;
	uint64_t progress_callback;
	uint64_t progress_callback_timeout;
};
typedef struct nssi_service nssi_service;
#define NSSI_SHORT_REQUEST_SIZE NNTI_REQUEST_BUFFER_SIZE
#define NSSI_SHORT_RESULT_SIZE NNTI_RESULT_BUFFER_SIZE

struct nssi_request_header {
	NNTI_transport_header_t transport_header;
	uint32_t id;
	uint32_t opcode;
	bool_t fetch_args;
	bool_t fetch_data;
	bool_t is_responseless;
	NNTI_buffer_t args_addr;
	NNTI_buffer_t data_addr;
	NNTI_buffer_t res_addr;
};
typedef struct nssi_request_header nssi_request_header;

struct nssi_result_header {
	NNTI_transport_header_t transport_header;
	uint32_t id;
	uint32_t opcode;
	uint32_t result_size;
	bool_t fetch_result;
	NNTI_buffer_t result_addr;
	NNTI_buffer_t result_ack_addr;
	uint32_t rc;
};
typedef struct nssi_result_header nssi_result_header;

/* the xdr functions */

#if defined(__STDC__) || defined(__cplusplus)
extern  bool_t xdr_nssi_return_codes (XDR *, nssi_return_codes*);
extern  bool_t xdr_nssi_size (XDR *, nssi_size*);
extern  bool_t xdr_nssi_ssize (XDR *, nssi_ssize*);
extern  bool_t xdr_nssi_rpc_transport (XDR *, nssi_rpc_transport*);
extern  bool_t xdr_nssi_rpc_encode (XDR *, nssi_rpc_encode*);
extern  bool_t xdr_nssi_service (XDR *, nssi_service*);
extern  bool_t xdr_nssi_request_header (XDR *, nssi_request_header*);
extern  bool_t xdr_nssi_result_header (XDR *, nssi_result_header*);

#else /* K&R C */
extern bool_t xdr_nssi_return_codes ();
extern bool_t xdr_nssi_size ();
extern bool_t xdr_nssi_ssize ();
extern bool_t xdr_nssi_rpc_transport ();
extern bool_t xdr_nssi_rpc_encode ();
extern bool_t xdr_nssi_service ();
extern bool_t xdr_nssi_request_header ();
extern bool_t xdr_nssi_result_header ();

#endif /* K&R C */

#ifdef __cplusplus
}
#endif

#endif /* !_TRIOS_NSSI_TYPES_XDR_H_RPCGEN */
